#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
//#include "config.h"
#include "file.h"


#define BUF_SIZE 4096
#define MAX_PATH 4096
#define MAX_FILENAME 128
#define LOG_OUTPUT_STDERR_DEFAULT 1
#define LOG_OUTPUT_FILE_DEFAULT 1
#define LOG_LIMIT_DEFAULT ((long)(1024*1024))

static char *exe_dpath;
// ֥ǥ쥯ȥ򥫥Ȥ˲
// @note file_initprint_logǽ뤫顢ޤlog_fpathꤹ
static char save_dpath[MAX_PATH] = "./";
static char log_filename[MAX_FILENAME] = "";
static char log_fpath[MAX_PATH] = "";
static int log_output_stderr = LOG_OUTPUT_STDERR_DEFAULT;
static int log_output_file = LOG_OUTPUT_FILE_DEFAULT;
static long log_limit = LOG_LIMIT_DEFAULT;
static int enable_file = 0;


int file_init(char *argv0, char *dpath, char *save_dname, char *log_fname){
    char *home;
    char buf[BUF_SIZE];

    strcpy(log_filename, log_fname);
    // Ȥꤢlog_fpathꤹ
    set_log_fpath(log_filename);

    // ֥ǥ쥯ȥꤷ
    if (dpath != NULL){
        return set_save_dpath(dpath);
    }
    home = getenv("HOME");
    // HOME¸ߤ
    if (home != NULL){
        sprintf(buf, "%s/%s", home, save_dname);
        return set_save_dpath(buf);
    }
    // HOMEʤм¹ԥեΥǥ쥯ȥ򥻡֥ǥ쥯ȥˤ
    sprintf(buf, "%s", exe_dpath);
    return set_save_dpath(buf);
}

char *get_exe_dpath(char *argv0){
    static char dir[EXE_DIRNAME_MAX];
    char *sp = dir;
    char *ep;

    ep = strrchr(argv0, '/');
    // СХѥĤǵưƤ顢ѥʬ֤
    // Win32Ǥargv[0]ϥեѥʤΤǡǽ
    if (ep != NULL){
        while (argv0 != ep+1){
            //            printf("%p %p %c\n", sp, ep, *argv0);
            *sp = *argv0;
            sp ++;
            argv0 ++;
        }
        *sp = '\0';
        return dir;
    }
    // ¹ԥե̾ΤߤξPATH˥å
    else {
        sp = getenv("PATH");
        ep = strchr(sp, ':');
        while (ep != NULL){
            strncpy(dir, sp, ep-sp);
            dir[ep-sp] = '/';
            strcpy(dir + (ep - sp + 1), argv0);
            //            printf("|%s|\n", dir);
            // ѥ˼¹ԥե̾Υե뤬¹°դǤ
            // 줬ȸʤ
            if (access(dir, X_OK) == 0){
                dir[ep-sp+1] = '\0';
                return dir;
            }
            sp = ep + 1;
            ep = strchr(sp, ':');
        }
        return NULL;
    }
}

char *get_save_dpath(void){
    return save_dpath;
}

int set_save_dpath(char *dpath){
    strcpy(save_dpath, dpath);
    if (check_dir(save_dpath) == 0){
        log_warn("Cannot find '%s'.\n", save_dpath);
        if (make_dir(save_dpath) == 0){
            log_warn("Created '%s'.\n", save_dpath);
        }
        else {
            log_warn("Creating '%s' failed. Saving functions disabled.\n",
                     save_dpath);
            // ¸ǥ쥯ȥκ˼Ԥ顢
            // ʸΥǡload/saveԲ
            return 1;
        }
    }
    // νϥѥ򿷤dpath˺
    set_log_fpath(log_filename);
    enable_file = 1;
    return 0;
}

char *get_data_fpath(char *filename, char *fpath){
    sprintf(fpath, "%s/%s", save_dpath, filename);
    //	printf("open_data path:%s:\n", path);
	return fpath;
}

// SAVE_DIR˥⡼modeǥǡեfile򳫤
// 
FILE *open_data(char *filename, char *mode,
                char *application_id, int application_id_size,
                unsigned char *major_version, unsigned char *minor_version)
{
    char fpath[BUF_SIZE];
    FILE *fp;
    unsigned char id[BUF_SIZE];

    if (!enable_file) return NULL;
    if (get_data_fpath(filename, fpath) == NULL) return NULL;
    fp = fopen(fpath, mode);
    if (fp == NULL) return NULL;

    // read openΤȤ
    if (strchr(mode, 'r')){
        // إåפʤɤ߹
        fread(id, 1, application_id_size, fp);
        if (memcmp(id, application_id, application_id_size) != 0){
            fclose(fp);
            // ΥեϾ񤭤ʤ褦˥͡षƤ
            rename_data(filename);
            return NULL;
        }
        // Сɤ߽Ф
        fread(major_version, sizeof(unsigned char), 1, fp);
        fread(minor_version, sizeof(unsigned char), 1, fp);
        //        printf("ver:%d %d\n", *major_version, *minor_version);
	}
    // write openΤȤ
    else {
        // إå񤭹
        fwrite(application_id, application_id_size, 1, fp);
        // С񤭹
        fwrite(major_version, sizeof(unsigned char), 1, fp);
        fwrite(minor_version, sizeof(unsigned char), 1, fp);
        //        printf("ver:%d %d\n", *major_version, *minor_version);
    }
    return fp;
}

int fwrite_uint(FILE *fp, unsigned int *value, int num){
    int i, j;
    unsigned char c;

    for (i = 0 ; i < num ; i++){
        for (j = 3 ; j >= 0 ; j--){ // ̥ХȤ˽
            c = (*value >> (8 * j)) & 0xff;
            fwrite(&c, sizeof(unsigned char), 1, fp);
        }
        value ++;
    }
    return 1;
}
int fread_uint(FILE *fp, unsigned int *value, int num){
    int i, j;
    unsigned char c;

    for (i = 0 ; i < num ; i++){
        *value = 0;
        for (j = 3 ; j >= 0 ; j--){ // ̥ХȤ
            fread(&c, sizeof(unsigned char), 1, fp);
            *value |= (c << (8 * j));
        }
        value ++;
    }
    return 1;
}


int set_log_fpath(char *log_filename){
	if (log_filename){
        sprintf(log_fpath, "%s/%s", save_dpath, log_filename);
	}
    else {
        log_fpath[0] = '\0';
    }
    return 0;
}

int print_log(const char *msg){
	FILE *fp;
    time_t current_time;
    char buf[BUF_SIZE];

    if (log_output_stderr){
        fputs(msg, stderr);
    }
    if (!log_output_file) return 1;
    if (log_fpath[0] == '\0') return 1;
    fp = fopen(log_fpath, "ab");
    if (!fp) return 1;
    // եΥlog_limitĶƤ顢ɲý񤭹ߤϤ
    // @note Хˤ̵¥롼print_logƤФ줿Ȥ
    // ǥ򤢤դ줵Τɤ
    //    printf("LOG LIMIT CHECK: ftell:%ld LOG_LIMIT:%ld\n", ftell(fp), log_limit);
    if (ftell(fp) > log_limit){
        // @todo դ줿񤭹ߤǤϤʤ͡षƥȥ饤褦
        //       ѹ
        fprintf(stderr, 
                "Error: The size of log file '%s' exceeds the limit "
                "(%ldMBytes).\n",
                log_fpath, log_limit/1024/1024);
        return 1;
    }
    fclose(fp);
    fp = fopen(log_fpath, "a");
    if (!fp) return 1;
    time(&current_time);
    strftime(buf, BUF_SIZE, "%Y-%m-%d %H:%M:%S ", localtime(&current_time));
    fputs(buf, fp);
    fputs(msg, fp);
    fclose(fp);
	return 0;
}

int log_warn(char *fmt, ...){
	va_list ap;
	char buf[BUF_SIZE] = "Warning: ";

	va_start(ap, fmt);
	vsprintf(buf+strlen(buf), fmt, ap);
    va_end(ap);
	return print_log(buf);
}

int log_error(char *fmt, ...){
	va_list ap;
	char buf[BUF_SIZE] = "Error: ";

	va_start(ap, fmt);
	vsprintf(buf+strlen(buf), fmt, ap);
    va_end(ap);
	return print_log(buf);
}


int make_dir(char *dpath){
    return mkdir(dpath, MAKEDIR_MODE);
}

int check_dir(char *dpath){
    struct stat buf;
    // stat()˼Ԥå
    if (stat(dpath, &buf) != 0){
        return 0;
    }
    else {
        return S_ISDIR(buf.st_mode);
    }
}

int rename_data(char *filename){
    char fpath[MAX_PATH];
    char buf[MAX_PATH];
    int len, no = 0, i;

    get_data_fpath(filename, fpath);
    len = strlen(fpath);
    strcpy(buf, fpath);
    for (i = 0 ; i < 1000 ; i++){
        sprintf(buf+len, ".%03d", no);
        no++;
        if (rename(fpath, buf) == 0) return 0;
    }
    return -1;
} 


void set_log_output_stderr(int val){
    log_output_stderr = val;
}
void set_log_output_file(int val){
    log_output_file = val;
}
void set_log_limit(long val){
    log_limit = val;
}
