#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "main.h"
#include "game.h"
#include "gameend.h"
#include "draw.h"
#include "obj.h"
#include "stage.h"
#include "emap.h"
#include "uty.h"

dir_t move_dir = di_none;
static obj_t *chee;

static int slow = 0;
int is_paused = 0;
int jump_key_released = 1;
int has_space_released = 1;

static time_t sec = 0;
static int frames = 0;
static int timestep = 0;

void check_keys(void);
void check_keys_paused(void);
void set_player_move(int key, int is_down);
void exec_game_step(void);
void pause_game(int flag);

game_t game;


void game_init(void){
}

void setup_game(void){
	obj_t *sign;
	int v;
	int i;
	objective_t *objective;

	memset(game.record, 0, sizeof(game.record));
	jump_key_released = 1;
    slow = 0;
    SetTime(GAME_TIME_INIT);
    timestep = 0;
    game.frames_per_sec = 0;
#ifdef DEBUG
	game.show_hitmarker = 0;
#endif
	frames = 0;
    sec = 0;
    setup_stage();
    chee = get_chee();
    game.gondin_toeat = get_current_stage_gondin_toeat();
    game.gondin_total = get_current_stage_gondin_total();
	for (i = 0 ; i < re_end ; i++){
		game.objective_ix_table[i] = -1;
	}
	for (i = 0 ; i < OBJECTIVE_NUM ; i++){
		objective = get_stage_objective(i);
		if (objective->entry != re_invalid){
			game.objective_ix_table[objective->entry] = i;
            game.objectives[i].op = objective->op;
            game.objectives[i].val = objective->val;
            if (objective->incdec == id_inc){
				if (objective->op == oo_ge){
	                game.objectives[i].stat = st_notyet;
		            game.objectives[i].stat_fontseq[0] = fi_checkbox;
				}
				else {
	                game.objectives[i].stat = st_sofar;
		            game.objectives[i].stat_fontseq[0] = fi_check_weak;
				}
			}
            else { // id_dec
				if (objective->op == oo_ge){
	                game.objectives[i].stat = st_sofar;
		            game.objectives[i].stat_fontseq[0] = fi_check_weak;
				}
				else {
	                game.objectives[i].stat = st_notyet;
		            game.objectives[i].stat_fontseq[0] = fi_checkbox;
				}
            }
            game.objectives[i].stat_fontseq[1] = fi_end;
		}
        else {
            game.objectives[i].op = oo_none;
        }
	}
//	switch_current_emap();

	// ϻǴĤ˽ŤʤäƤɽ褦ˤƤ
	// en_signstatic顢ľswtich_current_emap()emapꤵƤ
	if ((v = check_emap_pos_obj_any_corner(chee, EM_SIGN)))
    {
        sign = GetEMapOwner(CheckVal2PosX(v), CheckVal2PosY(v), _sign);
        assert(sign != NULL);
		set_current_stage_sign_no(sign->u.sign.no);
	}

    EzSetKeyHandler(game_keyh);
    EzSetKeyReleaseHandler(game_key_releaseh);
	pause_game(1);
//    EzSetTimerHandler(game_timerh, GAME_SPEED);
    setup_draw_screen();
    draw_screen();
}
\


void game_keyh(int key){
    switch (key){
        /*
    case EZ_Left:
        chee->u.creature.move_x = -1;
        chee->dir = di_left;
		break;
    case EZ_Right:
        chee->u.creature.move_x = 1;
        chee->dir = di_right;
		break;
    case EZ_Up:
		puts("up");
        if (chee->u.creature.is_landed){
            chee->u.creature.jump_time = CHEE_JUMP_TIME;
            chee->u.creature.float_time = CHEE_FLOAT_TIME;
            chee->u.creature.is_landed = 0;
		}
 		break;
        */
    case 'h':
#ifdef DEBUG
		game.show_hitmarker = game.show_hitmarker ? 0 : 1;
#endif
        break;
    case 's':
        slow = slow ? 0 : 1;
        if (slow){
            EzSetTimerHandler(game_timerh, GAME_SPEED*10);
        }
        else {
            EzSetTimerHandler(game_timerh, GAME_SPEED);
        }
        break;
    case 'p':
    case 27:
        pause_game(is_paused ? 0 : 1);
        break;
    case 'r':
        if (get_extend_objective()){
            set_extend_objective(0);
        }
        else {
            set_extend_objective(1);
        }
        break;
    case 'g':
        if (State(chee) == os_ghost){
            ReqState(chee, NULL, os_retry);
        }
        else {
            ReqState(chee, NULL, os_bang);
        }
        break;
    default:
        break;
    }
}

void game_key_releaseh(int key){
    switch (key){
        /*
    case EZ_Left:
		if (chee->u.creature.move_x == -1){
			chee->u.creature.move_x = 0;
		}
		break;
    case EZ_Right:
		if (chee->u.creature.move_x == 1){
			chee->u.creature.move_x = 0;
		}
		break;
    case EZ_Up:
		puts("release up");
        chee->u.creature.jump_time = 0;
        chee->u.creature.float_time = 0;
		break;
    case 'h':
        game.show_hitmarker = 0;
        break;
        */
	case ' ':
	case 13:
		if (is_paused) pause_game(0);
		if (State(chee) == os_show_result){
			ReqState(chee, NULL, os_quit);
		}
		break;
    case 'q':
        ReqState(chee, NULL, os_quit);
        // ݡquitreqʤΤǥݡ
        pause_game(0);
        break;
    default:
        break;
    }
}

void check_keys(void){
    char keys[32];
    EzQueryKeymap(keys);
    if (EzIsKeyPress(keys, EZ_Left) && !EzIsKeyPress(keys, EZ_Right))
    {
        if (!IsStunned(chee)){
            chee->u.creature.move_x = -1;
        }
    }
    else if (EzIsKeyPress(keys, EZ_Right) && !EzIsKeyPress(keys, EZ_Left))
    {
        if (!IsStunned(chee)){
            chee->u.creature.move_x = 1;
        }
    }
    else {
        
        if (!IsStunned(chee)){
            chee->u.creature.move_x = 0;
        }
    }
    if (EzIsKeyPress(keys, ' ') || EzIsKeyPress(keys, EZ_Up)){
        // 		printf("has_space %d jump_release %d landed:%d sliding:%d\n", has_space_released, jump_key_released, IsLanded(chee), IsSliding(chee));
		if (!IsStunned(chee)){
        if (IsLanded(chee) && !IsSliding(chee) && jump_key_released && IsAlive(chee)){
  			IncGameRecord(re_jump_count);
            chee->u.creature.float_time = CHEE_FLOAT_TIME;
            chee->u.creature.jump_y = chee->u.creature.inertia_y;
            if (chee->u.creature.inertia_y < 0){
				chee->u.creature.jump_y_limit = chee->y - CHEE_JUMP_HEIGHT*2;
            }
            else if (chee->u.creature.inertia_y > 0){
				chee->u.creature.jump_y_limit = chee->y;
            }
            else {
				chee->u.creature.jump_y_limit = chee->y - CHEE_JUMP_HEIGHT;
            }
            chee->u.creature.jump_x = chee->u.creature.inertia_x;
            chee->u.creature.is_landed = 0;
			printf("jump ix=%d, iy=%d, jump_x = %d jump_y=%d\n", chee->u.creature.inertia_x, chee->u.creature.inertia_y, chee->u.creature.jump_x, chee->u.creature.jump_y);
	        jump_key_released = 0;

        }
		}
    }
    else {
        chee->u.creature.float_time = 0;
        jump_key_released = 1;
		has_space_released = 1;
		// ץǾ徺ͤ򥯥ꥢƤ
		chee->u.creature.jump_y = 0;
    }
#ifdef DEBUG    
    /*
    if (EzIsKeyPress(keys, 'S')){
        EzSetTimerHandler(game_timerh, GAME_SPEED*10);
    }
    else {
        EzSetTimerHandler(game_timerh, GAME_SPEED);
    }
    if (EzIsKeyPress(keys, 'H')){
        show_hitmarker = 1;
    }
    else {
        show_hitmarker = 0;
    }
    */
#endif
    /*
    if (EzIsKeyPress(keys, 'P')){
        EzSetTimerHandler(pause_timerh, GAME_SPEED);
    }
    if (EzIsKeyPress(keys, 'G')){
        if (State(chee) == os_ghost){
            ReqState(chee, NULL, os_rebirth);
        }
        else {
            ReqState(chee, NULL, os_bang);
        }
    }
    if (EzIsKeyPress(keys, 'Q')){
        ReqState(chee, NULL, os_quit);
    }
*/
}


void pause_game(int flag){
    if (flag){
        EzSetTimerHandler(pause_timerh, GAME_SPEED);
        is_paused = 1;
    }
    else {
        EzSetTimerHandler(game_timerh, GAME_SPEED);
        is_paused = 0;
        reset_initial_pause();
    }
}

void game_timerh(void){
    time_t new_sec;
    check_keys();
    exec_game_step();
    draw_screen();
    if (!IsAlive(chee)){
        EzSetTimerHandler(game_timerh, DEAD_SPEED);
//        printf("game: dead chee state:%d ctr:%d\n", State(chee), Ctr(chee));
        switch (State(chee)){
        case os_retry:
            setup_game();
            break;
        case os_gameover:
            if (Ctr(chee) == 0){
	            printf("SHOW GAMEOVER ON!\n");
				setup_gameover();
            } 
            break;
        case os_show_result:
            if (Ctr(chee) == 0){
            printf("SHOW_RESULT ON!\n");
				setup_gameclear();
            } 
            break;
        case os_quit:
            // ˴qȴ⡢
            // +1̤¸Ƥ
            save_current_stage_record(get_current_stage_name());
            set_main_state(ms_select_stage);
            break;
        default:
            break;
        }
    }
	else { // CheeAliveδ֤TIMEϸ
	    timestep ++;
		// TIME0ˤʤä餽ʾ帺ʤ
		if (timestep == GAME_FPS && GetTime() > 0){
			DecTime();
	        timestep = 0;
		}
	}
    new_sec = time(NULL);
    if (new_sec != sec){
        sec = new_sec;
        game.frames_per_sec = frames;
        frames = 0;
    }
    frames ++;
}
void pause_timerh(void){
    time_t new_sec;
    //    check_keys_paused();
	draw_pause_message();
    draw_screen();
    new_sec = time(NULL);
    if (new_sec != sec){
        sec = new_sec;
        game.frames_per_sec = frames;
        frames = 0;
    }
    frames ++;
}



void exec_game_step(void){
    //    move_obj_list();
    puts("-----");
    forall_obj(act_obj, oc_hard_dynamic);
    switch_current_emap();
	act_obj(chee);
    forall_obj(act_obj, oc_soft_dynamic);
    apply_all_req();
}


// Ǥο٤1䤹
// Τʾˤʤä1̤ʤ0֤
int inc_gondin_eaten(void){
	IncGondinEaten();
	inc_gondin_eaten_fontseq();
	if (GetGondinEaten() >= game.gondin_toeat){
		return 1;
	}
	return 0;
}

void quit_game(void){
	ReqState(chee, NULL, os_quit);
}
void retry_game(void){
	ReqState(chee, NULL, os_retry);
}


int update_objective_stat_inc(record_entry_t re){
	int ix;

	if ((ix = game.objective_ix_table[re]) != -1){
		if (game.objectives[ix].op == oo_ge){
			printf("update objective_stat: check %d >= %d\n", game.record[re], game.objectives[ix].val);
			if (game.record[re] >= game.objectives[ix].val){
				game.objectives[ix].stat = st_done;
				game.objectives[ix].stat_fontseq[0] = fi_check;
				return 1;
			}
		}
		else {
			if (game.record[re] > game.objectives[ix].val){
				game.objectives[ix].stat = st_failed;
				game.objectives[ix].stat_fontseq[0] = fi_multiply;
				return 0;
			}
		}
	}
	return 0;
}
int update_objective_stat_dec(record_entry_t re){
	int ix;

	if ((ix = game.objective_ix_table[re]) != -1){
		if (game.objectives[ix].op == oo_ge){
			if (game.record[re] < game.objectives[ix].val){
				game.objectives[ix].stat = st_failed;
				game.objectives[ix].stat_fontseq[0] = fi_multiply;
				return 0;
			}
		}
		else {
			printf("update objective_stat: check %d <= %d\n", game.record[re], game.objectives[ix].val);
			if (game.record[re] <= game.objectives[ix].val){
				game.objectives[ix].stat = st_done;
				game.objectives[ix].stat_fontseq[0] = fi_check;
				return 1;
			}
		}
	}
	return 0;
}

game_objective_t *get_game_objective(int no){
    return game.objectives;
}

void finalize_objective_stat(void){
	int i;

    for (i = 0 ; i < OBJECTIVE_NUM ; i++){
        if (game.objectives[i].op != oo_none){
            if (game.objectives[i].stat == st_sofar){
                game.objectives[i].stat = st_done;
				game.objectives[i].stat_fontseq[0] = fi_check;
            }
        }
    }
}

void inc_kill_record(obj_type_t type){
	record_entry_t re;

	re = kill_ot2re(type);
	if (re == re_invalid) return;	
	IncGameRecord(re);
}


