#ifndef OBJ_H
#define OBJ_H
#include "config.h"
#include "uty.h"
#include "param.h"

#define Ltx(obj) ((obj)->x)
#define Lty(obj) ((obj)->y)
#define Rtx(obj) ((obj)->x+(obj)->width-1)
#define Rty(obj) ((obj)->y)
#define Lbx(obj) ((obj)->x)
#define Lbpx(obj) ((obj)->prev_x)
#define Lby(obj) ((obj)->y+(obj)->height-1)
#define Rbx(obj) ((obj)->x+(obj)->width-1)
#define Rbpx(obj) ((obj)->prev_x+(obj)->width-1)
#define Rby(obj) ((obj)->y+(obj)->height-1)
#define GridX(obj) (Ltx(obj) >> GRID_SCALE)
#define GridY(obj) (Lty(obj) >> GRID_SCALE)
#define ObjName(obj) (get_type_name((obj)->type)

typedef enum {
    oc_begin = 0,
    oc_static = 0,
    oc_hard_dynamic,
    oc_soft_dynamic,
    oc_end
} obj_class_t;

#define OS_ALIVE (1 << 13)
#define OS_STUN (1 << 12)

typedef enum {
    os_invalid = 0,
	os_retry,    // Cheeꤹȥơꥹ
	os_quit,     // cheeꤹȥơ쥯Ȥ
    os_ghost,    // Cheeͩ
	os_gameover, // ४С
	os_exit,
	os_clear, // Cheeơꥢ
	os_show_result, // ơꥢåɽ
    os_smash_h1, // ʿ1ñ٤줿֡ƥåפbang˰ܹ
    os_smash_h2, // ʿ2ñ٤줿֡ƥåפbang˰ܹ
    os_smash_v1, // ľ1ñ٤줿֡ƥåפbang˰ܹ
    os_smash_v2, // ʿ2ñ٤줿֡ƥåפbang˰ܹ
    os_bang,     // եåܸʣ뤬ƥåפos_dead
    os_pierced,  // ȤǤ˻ɤä
    os_burned,   // ǾǤ
	os_electrocuted, // ХꥢǴŤ
    os_eaten,    // ٤줿ν()ϥ֥Ȱ¸
    os_digested, // ٤Ƥޤò档
	os_dead,     // ˴֥Ⱥkill_recordΤburnedbangʤɤ餳
    os_req_on,
    os_req_off,
    os_on,
    os_off,
//    os_pushed_up, // եȤå1ñ̲夲Τ˻Ȥ
	os_weighted_on,
	os_weighted_on_int,
	os_weighted_off,
	os_weighted_off_int,
    os_nonweighted_on,
//    os_nonweighted_on_int,
    os_nonweighted_off,
    os_goal_req_open, // 򳫤Ϥ
	os_goal_opening,
	os_goal_opened,
	os_goal_closing,
	os_gondin_eaten,
    os_nya_halting,
    
    os_alive_begin = OS_ALIVE,

    os_none,     // ̾¸ 
    os_digesting,// 𤬾ò档
    os_vomitting,// 𤬹ǤФ
    os_eating,   // ٤Ƥ(𡢤ä)
	os_blast, // Gagga
	os_head_high,    // μ岼
	os_head_low,
	os_breath_high, // ι
	os_breath_low,
	os_standing,
    os_cancel,   // ưߡȤꤢῩߤ˻Ȥ
    os_siguku_landed, // (ɹ̴ޤ)
    os_siguku_splashing, // 
    os_siguku_freezing,
	os_jumeme_melting_upper,
	os_jumeme_melting_side,
	os_jumeme_melting_lower,
    os_mingo_attack, // os_attackȤos_blastǤ?
    
	os_blasted = OS_ALIVE + OS_STUN, // Ф
    os_teleporting,
    os_chee_eating, // Ǥ򿩤٤Ƥ롣ǽˤ뤿STUN°

} obj_state_t;

typedef enum {
    er_none = 0,
    er_smash_h1 = os_smash_h1,
    er_smash_h2 = os_smash_h2,
    er_smash_v1 = os_smash_v1,
    er_smash_v2 = os_smash_v2,
    er_excluded_horizontal = 0x100,
    er_excluded_vertical = 0x200,
} exclude_result_t;

#define IsSmashed(re) ((re)&0xff)
#define IsExcludedHorizontal(re) ((re)&0x100)
#define IsExcludedVertical(re) ((re)&0x200)
#define IsExcluded(re) ((re)&0x300)
#define ExcludeResult2SmashState(re) ((re)&0xff)

typedef enum {
//    at_immune_ojigiri, // ˿٤ʤ
	at_meat,           // ưʪ(Ῡо)
	at_vegetable,      // ʪ(ȿʤäϲ)
	at_item,           // (!! Ū˹?)

    at_rooted,         // 򲼤Ƥ(exclude줿¨) 
	at_can_climb,    // ʤФ
	at_immune_pierce,   // ̵
	at_immune_flame,    // ̵
	at_immune_water,    // ̵
	at_turn_to_mist,    // Фˤ줿Ȥ̸ˤʤ(̵ˤʤ)
} attr_bit_t;

#define  SetAttr(obj, at)                        \
     ((obj)->attr |= (1 << (at)))
#define CheckAttr(obj, at)                 \
     ((obj)->attr & (1 << (at)))

typedef enum {
    ot_begin = 0, ot_none = 0,

	ot_gondin,   // ǥμ

	ot_hatopo,   // ϤȤ
	ot_gagga,    // ä
	ot_yaramasi, // 
    ot_ojigiri,  // 
	ot_sue,      // 
	ot_chu,      // ä
    ot_mingo,    // ߤ
	ot_jumeme,   // 
	ot_siguku,   // 
    ot_chee,     // ץ쥤䡼
    ot_creature_end,
	ot_blank = ot_creature_end,    // 
	ot_teleport_dest, // ƥݡ(ºݤˤ϶Ȥʤꥪ֥ȤȤƤʤ)
	ot_teleporter,
	ot_pipe,
	ot_wall,     // ˲ǽưʤ
    ot_fwall,    // ˲ǽ
	ot_iwall,    // ɹ
	ot_barrier,  // Хꥢ
	ot_goal,
    ot_slope_l,  // ̺
    ot_slope_r,
    ot_stairs_l,  // ʺ
    ot_stairs_r,
    ot_rstairs_l,  // դʺ
    ot_rstairs_r,
	ot_sign,
	ot_sign_hang,




	ot_lift,     // ١
	ot_mswitch,  // ⡼󥿥ꥹå(äƤ֤ON)
	ot_aswitch,  // 륿͡ȥå(٤ON/OFFڤ괹)

    ot_nya,      // 
	ot_punch,    // 
	ot_flame,

    ot_sting,    // ˲ǽưǽ
                 // ΥפcreateؿƤ֤ȤΤ߻Ȥ졢
                 //   ºݤˤϻꤷ˱ʲΤ줫
                 //   mapեˤñ쥷ܥ+ǵҤ
                 //   Ƚ꤬ۤʤ
                 //   ¹Ϥ줾̥פȤΨ褤Ǥ롣
    ot_sting_l,  // 
    ot_sting_r,  // 
    ot_sting_u,  // 
    ot_sting_d,  // 


	ot_hub,
//    ot_mvfloor,  // ư
    ot_end
} obj_type_t;


typedef struct {
    int move_x;         // ʿΰư
    int land_ofst;
    int inertia_x;      // եȤδ(׳ϻjump_x)
    int inertia_y;      // եȤδ(׳ϻjump_y)
                        // եȤδϻeb_push_leftʤɤǷޤ뤬
                        //   ˤϥեȤƶʤΤǡ
                        //   δͤȤ϶̤ɬפ
    int jump_x;         // ׻οʿɲðư(եȤΥ֡ʬ)
    int jump_y;         // ׻ξ岼ɲðư(եȤΥ֡ʬ)
    int float_time;     // ڶ(徺+ʿ)֥
	int jump_y_limit;   // פǤã־
	int blast_x;
	// !!! ʲΥե饰ϥӥåȲ1ɤ˲ळȤƤ
    int is_landed;      // ϤƤ1
	int is_prev_landed;    // ϤƤ1
    int is_walking;     // ⤤Ƥ1
	int is_walk_blocked;// Ԥɤǥ֥åƤ1
	int is_sliding;     // Ƥʤ1
	// !!! stunnedstateƱȯΤǡstate¦ӥåȤɽ
	//    int is_stunned;     // ưǽ֤ʤ1
} obj_creature_t;

#define IsCreature(obj) ((obj)->type <= ot_chee)
#define MoveX(obj) ((obj)->u.creature.move_x)
#define SetMoveX(obj, val)  ((obj)->u.creature.move_x = (val))
#define SetMoveXDir(obj) ((obj)->u.creature.move_x = \
                          ((obj)->dir == di_left ? -1 : 1))
#define InertiaX(obj) ((obj)->u.creature.inertia_x)
#define SetInertiaX(obj, val)  ((obj)->u.creature.inertia_x = (val))
#define JumpX(obj) ((obj)->u.creature.jump_x)
#define SetJumpX(obj, val)  ((obj)->u.creature.jump_x = (val))
#define JumpY(obj) ((obj)->u.creature.jump_y)
#define SetJumpY(obj, val)  ((obj)->u.creature.jump_y = (val))
#define BlastX(obj) ((obj)->u.creature.blast_x)
#define SetBlastX(obj, val)  ((obj)->u.creature.blast_x = (val))
#define LbxOfst(obj) ((obj)->u.creature.land_ofst)
#define RbxOfst(obj) ((obj)->u.creature.land_ofst)
#define LandLx(obj) (Lbx(obj)+LbxOfst(obj))
#define LandRx(obj) (Rbx(obj)-RbxOfst(obj))
#define LandLpx(obj) (Lbpx(obj)+LbxOfst(obj))
#define LandRpx(obj) (Rbpx(obj)-RbxOfst(obj))
#define LandWidth(obj) ((obj)->width - (LbxOfst(obj)+RbxOfst(obj)))

//#define IsStunned(obj) ((obj)->u.creature.is_stunned)
//#define SetStunned(obj, val) ((obj)->u.creature.is_stunned = (val))
#define IsLanded(obj) ((obj)->u.creature.is_landed)
#define SetLanded(obj, val) ((obj)->u.creature.is_landed = (val))
#define IsPrevLanded(obj) ((obj)->u.creature.is_prev_landed)
#define SetPrevLanded(obj, val) ((obj)->u.creature.is_prev_landed = (val))
#define IsSliding(obj) ((obj)->u.creature.is_sliding)
#define SetSliding(obj, val) ((obj)->u.creature.is_sliding = (val))
#define IsWalkBlocked(obj) ((obj)->u.creature.is_walk_blocked)
#define SetWalkBlocked(obj, val) ((obj)->u.creature.is_walk_blocked = (val))
#define IsWalking(obj) ((obj)->u.creature.is_walking)
#define SetWalking(obj, val) ((obj)->u.creature.is_walking = (val))
#define IsRooted(obj) (CheckAttr(obj, at_rooted))
#define IsMeat(obj) (CheckAttr(obj, at_meat))
#define IsVegetable(obj) (CheckAttr(obj, at_vegetable))
#define IsImmuneFlame(obj) (CheckAttr(obj, at_immune_flame))
#define IsImmuneWater(obj) (CheckAttr(obj, at_immune_water))
#define CanClimb(obj)  (CheckAttr(obj, at_can_climb))
#define IsTurnToMist(obj) (CheckAttr(obj, at_turn_to_mist))


#define GetDefaultMotion(obj, member) (creature_image_table[(obj)->type].member)
#define GetMotion(obj) ((obj)->motion)
#define SetMotion(obj, m) ((obj)->motion = (m))
#define SetMotionDir(obj, ml, mr)             \
    ((obj)->dir == di_left ?                  \
     ((obj)->motion = (ml)) :                 \
     ((obj)->motion = (mr)))
#define SetWalkMotion(obj)                                         \
    (((obj)->dir == di_left) ?                                     \
     ((GetMotion(obj) == GetDefaultMotion(obj, walk_l0)) ?         \
      SetMotion((obj), GetDefaultMotion((obj), walk_l1)) :         \
      SetMotion((obj), GetDefaultMotion((obj), walk_l0))) :        \
     ((GetMotion(obj) == GetDefaultMotion(obj, walk_r0)) ?         \
      SetMotion((obj), GetDefaultMotion((obj), walk_r1)) :         \
      SetMotion((obj), GetDefaultMotion((obj), walk_r0))))


typedef struct {
	int no; // signåֹ
} obj_sign_t;

typedef struct {
    int is_reverse; // 1ʤƧǤȤOFF
} obj_mswitch_t;

typedef struct {
	int lenctr;
} obj_flame_t;

struct obj_s;

typedef enum {lo_invalid, lo_and, lo_or, lo_xor, lo_majority} logic_t;
typedef enum {oo_off = -1, oo_invalid = 0, oo_on = 1} onoff_t;

typedef struct {
	logic_t logic;
    int is_reverse;
    int on_num;
	int in_num;
	int out_num;
	struct obj_s *in_objs[HUB_IN_MAX];
	struct obj_s *out_objs[HUB_OUT_MAX];
    unsigned int in_flags;
} obj_hub_t;

#define SetHubInFlag(obj, ix) ((obj)->u.hub.in_flags |= 1 << (ix))
#define ResetHubInFlag(obj, ix) ((obj)->u.hub.in_flags &= ~(1 << (ix)))
#define CheckHubInFlag(obj, ix) ((obj)->u.hub.in_flags & 1 << (ix))

/*
typedef struct {
    int beam_height;
} obj_teleporter_t;

typedef struct {
} obj_chee_t;

typedef struct {
} obj_hatopo_t;

typedef struct {
    int width;       // ʿ礭
    int xmin, xmax;  // ʿ(obj->x)κǾ
} obj_mvfloor_t;

*/

/*
typedef struct {
    int width;       // ʿ礭  
    int ymin, ymax;  // ľ(obj->y)κǾ
} obj_lift_t;
*/

#define STATE_STACK_SIZE 4

typedef struct obj_s{
    obj_class_t class;
    obj_type_t type;
    dir_t dir;
    int x, y;
	int prev_x, prev_y;
    int width;
    int height;
	struct obj_s *link;  // !! Ū? 
    int motion;         // ưѥΥǥå
    obj_state_t state; // ˴٤Ƥ롢ʤɤξ
    obj_state_t prev_state; // ξ
    obj_state_t state_stack[STATE_STACK_SIZE];
	int ctr_stack[STATE_STACK_SIZE];
	int state_stack_top;
    //    obj_state_t prev_state;
    int ctr;              // ʣƥåפstateѤΥ
    struct obj_s *prev, *next;
    int attr;
    union {
        obj_creature_t creature;
		obj_sign_t sign;
		obj_mswitch_t mswitch;
		obj_flame_t flame;
		obj_hub_t hub;
        //        obj_teleporter_t teleporter;
//		obj_nya_t nya;
        //        obj_mvfloor_t mvfloor;
        //        obj_lift_t lift;
    } u;
} obj_t;

typedef struct {
	// ֥˥֥ȸͭνɲä
	// set_emap_staticϤǹԤäƤ褤
	// set_emapϤ˾񤭤ΤǸ̤ʤ
	// Ȥޥå׾ǱΥ֥Ȥ̤ʤΤǡ
	// ܥ֥Ȥ򻲾Ȥ褦ʽ򤳤ǹԤäƤϤʤʤ
    void (*create)(obj_t *, int, int, dir_t);
	// ե졼Υ֥ȤưԤ
	// ˴ʤɤξ0֤ȤΥ֥Ȥ
	int (*setup)(obj_t *);
	int (*act)(obj_t *);  
	// Υ֥Ȥ褹
	int (*draw)(obj_t *);
	// Υ֥Ȥɲ衣
	// ƥ֥ȤdrawƤФ줿Ǽ¹Ԥ
	// ƥ֥ȤdrawƤӽФϥ֥˰¸Τǡ
	// ¾Υ֥Ȥξ夫Ϥ˽򵭽Ҥ
    int (*post_draw)(obj_t *);
	// ֥ȸͭưȡԤʤɰŪʵưԤ
	// actƤӽФ뤳ȤꤷƤꡢϥ֥Ȥ
	// creatureξact_creatureФ롣
    int (*set_action)(obj_t *);
    void (*set_motion)(obj_t *);
	void (*set_emap)(obj_t *);
} obj_funcs_t;

typedef struct {
    obj_type_t type;
    char *name;
    obj_class_t oclass;
    obj_funcs_t funcs;
} obj_info_t;

// ¾Υ֥Ȥstateѹꥯȥ塼
// ľstateѹȡ׵¦ѹ¦ν˰¸
// ܥߥ󥰤Τǡ
// ü塼ˤǡƥå˰
typedef struct {
    obj_t *dest;
    obj_t *src;
    obj_state_t state;
} state_req_entry_t;

#define State(obj) ((obj)->state)
#define PrevState(obj) ((obj)->prev_state)
#define SavePrevState(obj) ((obj)->prev_state = (obj)->state)

/*
#define PrevState(obj) ((obj)->prev_state)
#define SetState(obj, st)                    \
    (((obj)->prev_state = (obj)->state),     \
     ((obj)->state = st),                    \
     ((obj)->ctr = 0))
*/
#define Ctr(obj) ((obj)->ctr)
#define SetState(obj, st)                    \
    (((obj)->state_stack_top = 0),           \
     ((obj)->state = st),                    \
     ((obj)->ctr = 0))

#define PushState(obj, st)                                   \
    (assert((obj)->state_stack_top < STATE_STACK_SIZE),           \
     ((obj)->state_stack[(obj)->state_stack_top] = (obj)->state), \
     ((obj)->ctr_stack[(obj)->state_stack_top++] = (obj)->ctr), \
     ((obj)->state = st),                                    \
     ((obj)->ctr = 0))

#define PopState(obj)                                        \
    (assert((obj)->state_stack_top > 0),                            \
     ((obj)->state = (obj)->state_stack[--((obj)->state_stack_top)]), \
     ((obj)->ctr = (obj)->ctr_stack[(obj)->state_stack_top]))

#define PeekState(obj)                          \
    (assert((obj)->state_stack_top > 0),               \
     ((obj)->state_stack[(obj)->state_stack_top-1]))


#define SetCtr(obj, val)                        \
    ((obj)->ctr = val)
#define IncCtr(obj) ((obj)->ctr ++)

#define IsAlive(obj) (State(obj) & OS_ALIVE)
#define IsStunned(obj) (State(obj) & OS_STUN)
#define IsWalkable(obj) (State(obj) == os_none)
#define IsBlasted(obj) (State(obj) == os_blasted)


//    (State(obj) >= os_none &&                 
//     State(obj) < os_is_alive_end)

#define IsEating(obj) (State(obj) == os_eating)

#define ReqState(dest, src, st)                  \
    (push_obj_req(dest, src, st))




void obj_init(void);
void setup_obj_list(void);
obj_t *create_obj_grid(obj_type_t type, int x, int y, dir_t dir);
obj_t *create_obj(obj_type_t type, int x, int y, dir_t dir);
void delete_obj(obj_t *obj);
char *obj_type2name(obj_type_t type);
obj_type_t obj_name2type(char *name);
obj_t *create_sign_grid(obj_type_t type, int x, int y, int link_no);


void forall_obj(int(*f)(obj_t *), obj_class_t class);
//void act_obj_list(void);
int act_obj(obj_t *obj);
void setup_stage_obj_list(void);
int setup_stage_obj(obj_t *obj);
void draw_obj_list(void);
int draw_obj(obj_t *obj);
int post_draw_obj(obj_t *obj);

void clear_obj_req_queue(void);
void push_obj_req(obj_t *dest, obj_t *src, obj_state_t state);
void apply_req(obj_t *dest, obj_t *src, obj_state_t state);
void apply_all_req(void);

void create_chee(obj_t *obj, int ox, int oy, dir_t dir);
int setup_chee(obj_t *obj);
void set_chee(obj_t *obj);
obj_t *get_chee(void);
void create_gondin(obj_t *obj, int ox, int oy, dir_t dir);
int setup_gondin(obj_t *obj);
void create_hatopo(obj_t *obj, int ox, int oy, dir_t dir);
void create_yaramasi(obj_t *obj, int ox, int oy, dir_t dir);
void create_gagga(obj_t *obj, int ox, int oy, dir_t dir);
void create_ojigiri(obj_t *obj, int ox, int oy, dir_t dir);
void create_sue(obj_t *obj, int ox, int oy, dir_t dir);
void create_chu(obj_t *obj, int ox, int oy, dir_t dir);
void create_mingo(obj_t *obj, int ox, int oy, dir_t dir);
void create_jumeme(obj_t *obj, int ox, int oy, dir_t dir);
void create_siguku(obj_t *obj, int ox, int oy, dir_t dir);
void create_flame(obj_t *obj, int ox, int oy, dir_t dir);
void create_nya(obj_t *obj, int ox, int oy, dir_t dir);
void create_punch(obj_t *obj, int ox, int oy, dir_t dir);
void create_wall(obj_t *obj, int ox, int oy, dir_t dir);
void create_goal(obj_t *obj, int ox, int oy, dir_t dir);
void create_sign(obj_t *obj, int ox, int oy, dir_t dir);
void create_sting(obj_t *obj, int ox, int oy, dir_t dir);
void create_fwall(obj_t *obj, int ox, int oy, dir_t dir);
void create_iwall(obj_t *obj, int ox, int oy, dir_t dir);
void create_barrier(obj_t *obj, int ox, int oy, dir_t dir);
void create_pipe(obj_t *obj, int ox, int oy, dir_t dir);
void create_slope_l(obj_t *obj, int ox, int oy, dir_t dir);
void create_slope_r(obj_t *obj, int ox, int oy, dir_t dir);
void create_stairs_l(obj_t *obj, int ox, int oy, dir_t dir);
void create_stairs_r(obj_t *obj, int ox, int oy, dir_t dir);
void create_rstairs_l(obj_t *obj, int ox, int oy, dir_t dir);
void create_rstairs_r(obj_t *obj, int ox, int oy, dir_t dir);
//void create_mvfloor(obj_t *obj, int ox, int oy, dir_t dir);
//void set_grid_range_mvfloor(obj_t *obj, int xmin, int xmax);
//void set_grid_width_mvfloor(obj_t *obj, int width);
void create_lift(obj_t *obj, int ox, int oy, dir_t dir);
void create_mswitch(obj_t *obj, int ox, int oy, dir_t dir);
void create_aswitch(obj_t *obj, int ox, int oy, dir_t dir);
void create_teleporter(obj_t *obj, int ox, int oy, dir_t dir);
void create_teleport_dest(obj_t *obj, int ox, int oy, dir_t dir);
void create_hub(obj_t *obj, int ox, int oy, dir_t dir);
void set_hub_logic(obj_t *obj, logic_t logic);
void set_hub_reverse(obj_t *obj, int is_reverse);
void register_hub_in(obj_t *hub, obj_t *obj);
void register_hub_out(obj_t *hub, obj_t *obj);
void apply_req_to_hub(obj_t *hub, obj_t *src, obj_state_t state);
void print_hub(obj_t *hub);
void set_grid_width_static(obj_t *obj, int width);
void set_grid_width_dynamic(obj_t *obj, int width);
void set_grid_height_dynamic(obj_t *obj, int height);

//obj_state_t exclude_obj(obj_t *obj);
exclude_result_t exclude_obj(obj_t *obj);
int move_obj_horizontal(obj_t *obj, int xoffset);
int walk_obj(obj_t *obj, int xoffset);
int push_horizontal(obj_t *obj);
int push_diagonal(obj_t *obj);
int blast_horizontal(obj_t *obj);
int start_teleport_creature(obj_t *obj);
int teleport_creature(obj_t *obj);

int setup_creature(obj_t *obj);
int act_creature(obj_t *obj);
void set_emap_creature(obj_t *obj);
int act_chee(obj_t *obj);
void set_motion_chee(obj_t *obj);
void set_emap_chee(obj_t *obj);
int set_action_gondin(obj_t *obj);
void set_motion_gondin(obj_t *obj);
void set_emap_gondin(obj_t *obj);
int set_action_hatopo(obj_t *obj);
void set_motion_hatopo(obj_t *obj);
int set_action_yaramasi(obj_t *obj);
void set_motion_yaramasi(obj_t *obj);
void set_emap_yaramasi(obj_t *obj);
int set_action_ojigiri(obj_t *obj);
void set_motion_ojigiri(obj_t *obj);
int set_action_gagga(obj_t *obj);
void set_motion_gagga(obj_t *obj);
void set_emap_gagga(obj_t *obj);
int set_action_nya(obj_t *obj);
void set_motion_nya(obj_t *obj);
int set_action_sue(obj_t *obj);
void set_motion_sue(obj_t *obj);
int set_action_chu(obj_t *obj);
void set_motion_chu(obj_t *obj);
int set_action_mingo(obj_t *obj);
void set_motion_mingo(obj_t *obj);
void set_emap_mingo(obj_t *obj);
int set_action_jumeme(obj_t *obj);
void set_motion_jumeme(obj_t *obj);
void set_emap_jumeme(obj_t *obj);
int set_action_siguku(obj_t *obj);
void set_motion_siguku(obj_t *obj);
void set_emap_siguku(obj_t *obj);
int act_nya(obj_t *obj);
int setup_nya(obj_t *obj);
int act_punch(obj_t *obj);
void set_emap_punch(obj_t *obj);
//void move_mvfloor(obj_t *obj);
int act_lift(obj_t *obj);
int setup_lift(obj_t *obj);
void set_emap_lift(obj_t *obj);
int act_goal(obj_t *obj);
int act_fwall(obj_t *obj);
int act_iwall(obj_t *obj);
int act_pipe(obj_t *obj);
int act_barrier(obj_t *obj);
int setup_barrier(obj_t *obj);
void set_motion_barrier(obj_t *obj);
void set_emap_barrier(obj_t *obj);
int act_mswitch(obj_t *obj);
int setup_mswitch(obj_t *obj);
void on_aswitch(obj_t *obj);
int act_aswitch(obj_t *obj);
int setup_aswitch(obj_t *obj);
void set_emap_aswitch(obj_t *obj);
int act_teleporter(obj_t *obj);
int setup_teleporter(obj_t *obj);
void set_motion_teleporter(obj_t *obj);
void set_emap_teleporter(obj_t *obj);
int act_flame(obj_t *obj);
void set_emap_flame(obj_t *obj);

#endif
